#include "stdafx.h"

bool large_ID_Value(const ID_Value& refLeft, const ID_Value& refRight)
{
	return refLeft.Value > refRight.Value;
}

double sqrt_norm(const coord2D &in){return _hypot(in.x, in.y);}
double norm(const coord2D &in){return in.x * in.x + in.y * in.y;}
double inner_product(const coord2D a, const coord2D b){return a.x * b.x + a.y * b.y;}

//w肵_IDԂ
int ContinuousAreaCartogramUtility::ID_check(const int ID, const int N_V)
{
	if (ID < 0) return (ID + N_V);
	if (ID >= N_V) return (ID - N_V);
	return (ID);
}

//ӂ܂ގOp`CӂɊ܂܂Ȃ_ID𒲂ׂ
void ContinuousAreaCartogramUtility::Search_Vert(const int V1, const int V2, int *found_V1, int *found_V2, T_vector &T)
{
	int j, k, m, in_V[2];
	T_vector::iterator itr;

	in_V[0] = V1;
	in_V[1] = V2;
	sort(in_V, in_V + 2);

	*found_V1 = -1;
	*found_V2 = -1;

	for (itr = T.begin(); itr < T.end(); itr++){
		for (j=0; j<2; j++){
			if (in_V[0] == (*itr).V[j]){
				for (k=j+1; k<3; k++){
					if (in_V[1] == (*itr).V[k]){
						m = 0;
						while ((m==j)||(m==k)) ++ m;
						if (*found_V1==-1) *found_V1 = (*itr).V[m];
						else{
							*found_V2 = min(*found_V1, (*itr).V[m]);
							*found_V1 = max(*found_V1, (*itr).V[m]);
							return;
						}
					}
				}
			}
		}
	}
}

//t̎Op`̖ʐςvZ
double ContinuousAreaCartogramUtility::calc_tri_area_w_sign(co_vector &coord, const Triangle_Info T)
{
	return tri_area_w_sign(T.V[0], T.V[1], T.V[2], coord);
}

//O_Ō܂Op`̕tʐ
double ContinuousAreaCartogramUtility::tri_area_w_sign(const int p0, const int p1, const int p2, co_vector &coord)
{
	return tri_area_w_sign(coord[p0], coord[p1], coord[p2]);
}
double ContinuousAreaCartogramUtility::tri_area_w_sign(const coord2D p0, const coord2D p1, const coord2D p2)
{
	return ((p1.x - p0.x) * (p2.y - p0.y) + (p2.x - p0.x) * (p0.y - p1.y)) / 2;
}


//2{̐Ă邩𒲂ׂ
//[_̐ɂƂuĂȂvƔf
bool ContinuousAreaCartogramUtility::intersect(const int S0, const int E0, const int S1, const int E1, co_vector &coord)
{
	//\̖ꍇO
	if (max(coord[S0].x, coord[E0].x) <= min(coord[S1].x, coord[E1].x)
		|| max(coord[S0].y, coord[E0].y) <= min(coord[S1].y, coord[E1].y)
		|| min(coord[S0].x, coord[E0].x) >= max(coord[S1].x, coord[E1].x)
		|| min(coord[S0].y, coord[E0].y) >= max(coord[S1].y, coord[E1].y))
		return false;

	//[_LĂꍇ͌ĂȂƔ
	if (coord[S0]==coord[S1] || coord[E0]==coord[S1]
		|| coord[S0]==coord[E1] || coord[E0]==coord[E1]) return false;

	return ((tri_area_w_sign(S0, E0, S1, coord) * tri_area_w_sign(S0, E0, E1, coord) < 0.0)
		&& (tri_area_w_sign(S1, E1, S0, coord) * tri_area_w_sign(S1, E1, E0, coord) < 0.0));
}

void ContinuousAreaCartogramUtility::calc_sincos_ijk(const int i, const int j, const int k, co_vector &coord, double *sin, double *cos)
{
	coord2D E_vec[2];

	E_vec[0] = coord[i] - coord[j];
	E_vec[1] = coord[k] - coord[j];

	double tmp = sqrt(norm(E_vec[0]) * norm(E_vec[1]));
	*sin = (E_vec[0].x * E_vec[1].y - E_vec[0].y * E_vec[1].x) / tmp;
	*cos = (E_vec[0].x * E_vec[1].x + E_vec[0].y * E_vec[1].y) / tmp;
}

//_ii+1̋vZ
void ContinuousAreaCartogramUtility::calc_edge_length(const int i, i_vector &P_V, const int N_V, co_vector &coord, co_vector &E_vec, d_vector &e_d)
{
	E_vec[i] = coord[P_V[ID_check(i+1, N_V)]] - coord[P_V[i]];
	e_d[i] = sqrt_norm(E_vec[i]);
}

void ContinuousAreaCartogramUtility::calc_angle(const int i, const int N_V, co_vector &Edge_Vec, d_vector &e_d, d_vector &c_v, d_vector &s_v)
{
	int tmp_i = ID_check(i-1, N_V);
	double tmp = e_d[i]*e_d[tmp_i];	//Ӓ̐
	c_v[i] = -(Edge_Vec[i].x * Edge_Vec[tmp_i].x + Edge_Vec[i].y * Edge_Vec[tmp_i].y) / tmp;
	s_v[i] = (Edge_Vec[i].x * Edge_Vec[tmp_i].y - Edge_Vec[i].y * Edge_Vec[tmp_i].x) / tmp;
}

//ɓ_ꍇ
bool ContinuousAreaCartogramUtility::Point_In_ThreePoints(const coord2D Point, const coord2D P0, const coord2D P1, const coord2D P2)
{
	int unity = 1, two = 2, work_size = 66, info;
	double Y[2], X[4], work[66];
	char trans_N='N';

	if (Point.x > max(P0.x, max(P1.x, P2.x))) return false;
	if (Point.y > max(P0.y, max(P1.y, P2.y))) return false;
	if (Point.x < min(P0.x, min(P1.x, P2.x))) return false;
	if (Point.y < min(P0.y, min(P1.y, P2.y))) return false;

	Y[0] = Point.x - P0.x;
	Y[1] = Point.y - P0.y;

	X[0] = P1.x - P0.x;
	X[1] = P1.y - P0.y;
	X[2] = P2.x - P0.x;
	X[3] = P2.y - P0.y;

	dgels(&trans_N, &two, &two, &unity, X, &two, Y, &two, work, &work_size, &info);

	return Y[0]>=-EPS && Y[1]>=-EPS && Y[0]+Y[1]<=1.0+EPS;//ۂߌ덷΍
}

// EdgeIDݒ肷
void ContinuousAreaCartogramUtility::Set_Edge_ID(P_vector &P, E_vector &E)
{
	int same_ID;
	Edge_Info tmp_E;

	for (P_vector::iterator itr_P = P.begin(); itr_P < P.end(); itr_P ++){
		for (int i=0; i<int((*itr_P).V_ID.size()); i++){
			tmp_E = Edge_Info((*itr_P).V_ID[i], (*itr_P).V_ID[ID_check(i+1, int((*itr_P).V_ID.size()))]);

			same_ID = Search_Same_Edge(tmp_E, E);

			if (same_ID==-1){//V
				tmp_E.P[0] = int(itr_P - P.begin());
				tmp_E.P[1] = -1;
				E.push_back(tmp_E);
			}
			else E[same_ID].P[1] = int(itr_P - P.begin());
		}
	}
}

// O\ӂ̃Xg쐬
void ContinuousAreaCartogramUtility::Set_OuterEdge_ID(P_vector &P, E_vector &E)
{
	int same_ID;
	Edge_Info tmp_E;

	for (P_vector::iterator itr_P = P.begin(); itr_P < P.end(); itr_P ++){
		for (int i=0; i<int((*itr_P).V_ID.size()); i++){
			tmp_E = Edge_Info((*itr_P).V_ID[i], (*itr_P).V_ID[ID_check(i+1, int((*itr_P).V_ID.size()))]);

			same_ID = Search_Same_Edge(tmp_E, E);

			if (same_ID==-1){//V
				tmp_E.P[0] = int(itr_P - P.begin());
				tmp_E.P[1] = -1;
				E.push_back(tmp_E);
			}

			// łɕӂݒ肳Ăꍇɂ͍폜
			else E.erase(E.begin()+same_ID);
		}
	}
}

// ӂ
int ContinuousAreaCartogramUtility::Search_Same_Edge(Edge_Info tmp_E, E_vector &E)
{
	for (E_vector::iterator itr = E.begin(); itr < E.end(); itr ++)
		if (tmp_E==(*itr)) return int(itr - E.begin());
	return -1;
}

// JgOW̌_ݒ肷
void ContinuousAreaCartogramUtility::Set_Origin(V_vector &V, co_vector &coord)
{
	int i;
	coord2D min_coord(0.0, 0.0), max_coord(0.0, 0.0);

	for (V_vector::iterator itr = V.begin(); itr < V.end(); itr ++){
		if ((*itr).use){
			i=int(itr - V.begin());
			if (coord[i].x > max_coord.x) max_coord.x = coord[i].x;
			else if (coord[i].x < min_coord.x) min_coord.x = coord[i].x;

			if (coord[i].y > max_coord.y) max_coord.y = coord[i].y;
			else if (coord[i].y < min_coord.y) min_coord.y = coord[i].y;
		}
	}

	min_coord = (min_coord + max_coord)/2;

	for (co_vector::iterator itr_co = coord.begin(); itr_co < coord.end(); itr_co ++)
		*itr_co = *itr_co - min_coord;
}